/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"encoding/json"
	"time"
)

// checks if the SelfServiceAccountActivationRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &SelfServiceAccountActivationRequest{}

// SelfServiceAccountActivationRequest struct for SelfServiceAccountActivationRequest
type SelfServiceAccountActivationRequest struct {
	Id            *string        `json:"id,omitempty"`
	ApprovalToken NullableString `json:"approvalToken,omitempty"`
	Captcha       *CaptchaAnswer `json:"captcha,omitempty"`
	DateOfBirth   *time.Time     `json:"dateOfBirth,omitempty"`
	CernPassword  NullableString `json:"cernPassword,omitempty"`
	EdhPassword   NullableString `json:"edhPassword,omitempty"`
}

// NewSelfServiceAccountActivationRequest instantiates a new SelfServiceAccountActivationRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewSelfServiceAccountActivationRequest() *SelfServiceAccountActivationRequest {
	this := SelfServiceAccountActivationRequest{}
	return &this
}

// NewSelfServiceAccountActivationRequestWithDefaults instantiates a new SelfServiceAccountActivationRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewSelfServiceAccountActivationRequestWithDefaults() *SelfServiceAccountActivationRequest {
	this := SelfServiceAccountActivationRequest{}
	return &this
}

// GetId returns the Id field value if set, zero value otherwise.
func (o *SelfServiceAccountActivationRequest) GetId() string {
	if o == nil || IsNil(o.Id) {
		var ret string
		return ret
	}
	return *o.Id
}

// GetIdOk returns a tuple with the Id field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SelfServiceAccountActivationRequest) GetIdOk() (*string, bool) {
	if o == nil || IsNil(o.Id) {
		return nil, false
	}
	return o.Id, true
}

// HasId returns a boolean if a field has been set.
func (o *SelfServiceAccountActivationRequest) HasId() bool {
	if o != nil && !IsNil(o.Id) {
		return true
	}

	return false
}

// SetId gets a reference to the given string and assigns it to the Id field.
func (o *SelfServiceAccountActivationRequest) SetId(v string) {
	o.Id = &v
}

// GetApprovalToken returns the ApprovalToken field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *SelfServiceAccountActivationRequest) GetApprovalToken() string {
	if o == nil || IsNil(o.ApprovalToken.Get()) {
		var ret string
		return ret
	}
	return *o.ApprovalToken.Get()
}

// GetApprovalTokenOk returns a tuple with the ApprovalToken field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *SelfServiceAccountActivationRequest) GetApprovalTokenOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.ApprovalToken.Get(), o.ApprovalToken.IsSet()
}

// HasApprovalToken returns a boolean if a field has been set.
func (o *SelfServiceAccountActivationRequest) HasApprovalToken() bool {
	if o != nil && o.ApprovalToken.IsSet() {
		return true
	}

	return false
}

// SetApprovalToken gets a reference to the given NullableString and assigns it to the ApprovalToken field.
func (o *SelfServiceAccountActivationRequest) SetApprovalToken(v string) {
	o.ApprovalToken.Set(&v)
}

// SetApprovalTokenNil sets the value for ApprovalToken to be an explicit nil
func (o *SelfServiceAccountActivationRequest) SetApprovalTokenNil() {
	o.ApprovalToken.Set(nil)
}

// UnsetApprovalToken ensures that no value is present for ApprovalToken, not even an explicit nil
func (o *SelfServiceAccountActivationRequest) UnsetApprovalToken() {
	o.ApprovalToken.Unset()
}

// GetCaptcha returns the Captcha field value if set, zero value otherwise.
func (o *SelfServiceAccountActivationRequest) GetCaptcha() CaptchaAnswer {
	if o == nil || IsNil(o.Captcha) {
		var ret CaptchaAnswer
		return ret
	}
	return *o.Captcha
}

// GetCaptchaOk returns a tuple with the Captcha field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SelfServiceAccountActivationRequest) GetCaptchaOk() (*CaptchaAnswer, bool) {
	if o == nil || IsNil(o.Captcha) {
		return nil, false
	}
	return o.Captcha, true
}

// HasCaptcha returns a boolean if a field has been set.
func (o *SelfServiceAccountActivationRequest) HasCaptcha() bool {
	if o != nil && !IsNil(o.Captcha) {
		return true
	}

	return false
}

// SetCaptcha gets a reference to the given CaptchaAnswer and assigns it to the Captcha field.
func (o *SelfServiceAccountActivationRequest) SetCaptcha(v CaptchaAnswer) {
	o.Captcha = &v
}

// GetDateOfBirth returns the DateOfBirth field value if set, zero value otherwise.
func (o *SelfServiceAccountActivationRequest) GetDateOfBirth() time.Time {
	if o == nil || IsNil(o.DateOfBirth) {
		var ret time.Time
		return ret
	}
	return *o.DateOfBirth
}

// GetDateOfBirthOk returns a tuple with the DateOfBirth field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SelfServiceAccountActivationRequest) GetDateOfBirthOk() (*time.Time, bool) {
	if o == nil || IsNil(o.DateOfBirth) {
		return nil, false
	}
	return o.DateOfBirth, true
}

// HasDateOfBirth returns a boolean if a field has been set.
func (o *SelfServiceAccountActivationRequest) HasDateOfBirth() bool {
	if o != nil && !IsNil(o.DateOfBirth) {
		return true
	}

	return false
}

// SetDateOfBirth gets a reference to the given time.Time and assigns it to the DateOfBirth field.
func (o *SelfServiceAccountActivationRequest) SetDateOfBirth(v time.Time) {
	o.DateOfBirth = &v
}

// GetCernPassword returns the CernPassword field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *SelfServiceAccountActivationRequest) GetCernPassword() string {
	if o == nil || IsNil(o.CernPassword.Get()) {
		var ret string
		return ret
	}
	return *o.CernPassword.Get()
}

// GetCernPasswordOk returns a tuple with the CernPassword field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *SelfServiceAccountActivationRequest) GetCernPasswordOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.CernPassword.Get(), o.CernPassword.IsSet()
}

// HasCernPassword returns a boolean if a field has been set.
func (o *SelfServiceAccountActivationRequest) HasCernPassword() bool {
	if o != nil && o.CernPassword.IsSet() {
		return true
	}

	return false
}

// SetCernPassword gets a reference to the given NullableString and assigns it to the CernPassword field.
func (o *SelfServiceAccountActivationRequest) SetCernPassword(v string) {
	o.CernPassword.Set(&v)
}

// SetCernPasswordNil sets the value for CernPassword to be an explicit nil
func (o *SelfServiceAccountActivationRequest) SetCernPasswordNil() {
	o.CernPassword.Set(nil)
}

// UnsetCernPassword ensures that no value is present for CernPassword, not even an explicit nil
func (o *SelfServiceAccountActivationRequest) UnsetCernPassword() {
	o.CernPassword.Unset()
}

// GetEdhPassword returns the EdhPassword field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *SelfServiceAccountActivationRequest) GetEdhPassword() string {
	if o == nil || IsNil(o.EdhPassword.Get()) {
		var ret string
		return ret
	}
	return *o.EdhPassword.Get()
}

// GetEdhPasswordOk returns a tuple with the EdhPassword field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *SelfServiceAccountActivationRequest) GetEdhPasswordOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.EdhPassword.Get(), o.EdhPassword.IsSet()
}

// HasEdhPassword returns a boolean if a field has been set.
func (o *SelfServiceAccountActivationRequest) HasEdhPassword() bool {
	if o != nil && o.EdhPassword.IsSet() {
		return true
	}

	return false
}

// SetEdhPassword gets a reference to the given NullableString and assigns it to the EdhPassword field.
func (o *SelfServiceAccountActivationRequest) SetEdhPassword(v string) {
	o.EdhPassword.Set(&v)
}

// SetEdhPasswordNil sets the value for EdhPassword to be an explicit nil
func (o *SelfServiceAccountActivationRequest) SetEdhPasswordNil() {
	o.EdhPassword.Set(nil)
}

// UnsetEdhPassword ensures that no value is present for EdhPassword, not even an explicit nil
func (o *SelfServiceAccountActivationRequest) UnsetEdhPassword() {
	o.EdhPassword.Unset()
}

func (o SelfServiceAccountActivationRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o SelfServiceAccountActivationRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Id) {
		toSerialize["id"] = o.Id
	}
	if o.ApprovalToken.IsSet() {
		toSerialize["approvalToken"] = o.ApprovalToken.Get()
	}
	if !IsNil(o.Captcha) {
		toSerialize["captcha"] = o.Captcha
	}
	if !IsNil(o.DateOfBirth) {
		toSerialize["dateOfBirth"] = o.DateOfBirth
	}
	if o.CernPassword.IsSet() {
		toSerialize["cernPassword"] = o.CernPassword.Get()
	}
	if o.EdhPassword.IsSet() {
		toSerialize["edhPassword"] = o.EdhPassword.Get()
	}
	return toSerialize, nil
}

type NullableSelfServiceAccountActivationRequest struct {
	value *SelfServiceAccountActivationRequest
	isSet bool
}

func (v NullableSelfServiceAccountActivationRequest) Get() *SelfServiceAccountActivationRequest {
	return v.value
}

func (v *NullableSelfServiceAccountActivationRequest) Set(val *SelfServiceAccountActivationRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableSelfServiceAccountActivationRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableSelfServiceAccountActivationRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableSelfServiceAccountActivationRequest(val *SelfServiceAccountActivationRequest) *NullableSelfServiceAccountActivationRequest {
	return &NullableSelfServiceAccountActivationRequest{value: val, isSet: true}
}

func (v NullableSelfServiceAccountActivationRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableSelfServiceAccountActivationRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
